HDU-2795 线段树

Billboard 

At the entrance to the university, there is a huge rectangular billboard of size h*w (h is its height and w is its width). The board is the place where all possible announcements are posted: nearest programming competitions, changes in the dining room menu, and other important information. 

On September 1, the billboard was empty. One by one, the announcements started being put on the billboard. 

Each announcement is a stripe of paper of unit height. More specifically, the i-th announcement is a rectangle of size 1 * wi. 

When someone puts a new announcement on the billboard, she would always choose the topmost possible position for the announcement. Among all possible topmost positions she would always choose the leftmost one. 

If there is no valid location for a new announcement, it is not put on the billboard (that's why some programming contests have no participants from this university). 

Given the sizes of the billboard and the announcements, your task is to find the numbers of rows in which the announcements are placed.

Input

There are multiple cases (no more than 40 cases). 

The first line of the input file contains three integer numbers, h, w, and n (1 <= h,w <= 10^9; 1 <= n <= 200,000) - the dimensions of the billboard and the number of announcements. 

Each of the next n lines contains an integer number wi (1 <= wi <= 10^9) - the width of i-th announcement.

Output

For each announcement (in the order they are given in the input file) output one number - the number of the row in which this announcement is placed. Rows are numbered from 1 to h, starting with the top row. If an announcement can't be put on the billboard, output "-1" for this announcement.

Sample Input

3 5 5
2
4
3
3
3

Sample Output

1
2
1
3
-1

题目大意:一个h*w的公告牌,要在其上贴公告。

  • 输入的是1*wi的w值,这些是公告的尺寸
  • 接下来要满足的条件有:1、尽量往上,同一高度尽量靠左。2、求第n个广告所在的行数。3、没有合适的位置贴了则输出-1。转载题意

思路:这道题开始我想用每一行来建立一棵树,发现数据太大没法实现,离散也不行,最后发现可以建立一棵区间为1--n的线段树,这样就能够处理每一行的情况,要注意区间存放的是这个区间的最大值(也就是某一行所剩的空间最大值),应题目要求,每次都取查询左子树(因为我们建树是从1--n行建立的,最左边的区间就对应的高度就越高)

#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cmath>
#include<queue>
#include<algorithm>
using namespace std;
typedef long long ll;
#define lson id<<1,l,m
#define rson id<<1|1,m+1,r
const int M=2e5+10;
ll n;
ll c[M<<2];
ll h,w;
void push(ll x)
{
    c[x]=max(c[x<<1],c[x<<1|1]);
}
void build (ll id,ll l,ll r)
{
    if(l==r){c[id]=w;return;}
    ll m=(l+r)>>1;
    build(lson);
    build(rson);
    push(id);
}
ll query(ll id,ll l,ll r,ll p)//修改和查询放在一起
{
    if(l==r){c[id]-=p;return l;}//返回左子树
    ll m=(l+r)>>1;int res=0;
    if(p<=c[id<<1]) res=query(lson,p);//这里判断当前的宽度是否小于等于左子树的最大值
    else res=query(rson,p);
    push(id);//修改后要更改最大值
    return res;
}
int main()
{
    ios::sync_with_stdio(0);cin.tie(0);
    while(cin>>h>>w>>n)
    {
        memset(c,0,sizeof c);
        h=h>n?n:h;//这里很重要,h>n的时候是完全没有必要只会超出数组界限ACCESS_VIOLATION
        build(1,1,h);
        while(n--)
        {
            ll x;cin>>x;
            if(x>c[1])//树的最顶端是这个棵树的所剩区间的最大值
                cout<<-1<<endl;
            else
            {
            cout<<query(1,1,h,x)<<endl;
            }
        }
    }
}

其实由n的数量集就可以看出,这题在离散的情况下,建树只能建立关于行区间的(这里的行指输入的n是几,就建立几行,最差的情况不就是一行贴一张公告吗),用scanf的话是2000多ms,cin是接近6秒,所以最好解决线段树的问题时用scanf。

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值